Index: issm/trunk/src/m/parameterization/setflowequation.m
===================================================================
--- issm/trunk/src/m/parameterization/setflowequation.m	(revision 18081)
+++ issm/trunk/src/m/parameterization/setflowequation.m	(revision 18301)
@@ -1,4 +1,4 @@
 function md=setflowequation(md,varargin)
-%SETELEMENTSTYPE - associate a solution type to each element
+%SETFLOWEQUATION - associate a solution type to each element
 %
 %   This routine works like plotmodel: it works with an even number of inputs
@@ -70,7 +70,7 @@
 end
 
-%Check that no L1L2 or HO or FS for 2d mesh
+%Check that no HO or FS for 2d mesh
 if strcmp(domaintype(md.mesh),'2Dhorizontal')
-	if any(L1L2flag | FSflag | HOflag)
+	if any(FSflag | HOflag)
 		error('FS and HO elements not allowed in 2d mesh, extrude it first')
 	end
@@ -239,15 +239,15 @@
 end
 
-%Create MacaAyealHOApproximation where needed
+%Create element equations
 md.flowequation.element_equation=zeros(md.mesh.numberofelements,1);
 md.flowequation.element_equation(find(noneflag))=0;
 md.flowequation.element_equation(find(SIAflag))=1;
 md.flowequation.element_equation(find(SSAflag))=2;
-md.flowequation.element_equation(find(L1L2flag))=8;
-md.flowequation.element_equation(find(HOflag))=3;
-md.flowequation.element_equation(find(FSflag))=4;
-md.flowequation.element_equation(find(SSAHOflag))=5;
-md.flowequation.element_equation(find(SSAFSflag))=6;
-md.flowequation.element_equation(find(HOFSflag))=7;
+md.flowequation.element_equation(find(L1L2flag))=3;
+md.flowequation.element_equation(find(HOflag))=4;
+md.flowequation.element_equation(find(FSflag))=5;
+md.flowequation.element_equation(find(SSAHOflag))=6;
+md.flowequation.element_equation(find(SSAFSflag))=7;
+md.flowequation.element_equation(find(HOFSflag))=8;
 
 %border
@@ -258,16 +258,14 @@
 %Create vertices_type
 md.flowequation.vertex_equation=zeros(md.mesh.numberofvertices,1);
+pos=find(nodeonSIA);
+md.flowequation.vertex_equation(pos)=1;
 pos=find(nodeonSSA);
 md.flowequation.vertex_equation(pos)=2;
 pos=find(nodeonL1L2);
-md.flowequation.vertex_equation(pos)=8;
+md.flowequation.vertex_equation(pos)=3;
 pos=find(nodeonHO);
-md.flowequation.vertex_equation(pos)=3;
-pos=find(nodeonSIA);
-md.flowequation.vertex_equation(pos)=1;
-pos=find(nodeonSSAHO);
+md.flowequation.vertex_equation(pos)=4;
+pos=find(nodeonFS);
 md.flowequation.vertex_equation(pos)=5;
-pos=find(nodeonFS);
-md.flowequation.vertex_equation(pos)=4;
 if any(FSflag),
 	pos=find(~nodeonFS);
@@ -276,15 +274,17 @@
 	end
 end
+pos=find(nodeonSSAHO);
+md.flowequation.vertex_equation(pos)=6;
 pos=find(nodeonHOFS);
 md.flowequation.vertex_equation(pos)=7;
 pos=find(nodeonSSAFS);
-md.flowequation.vertex_equation(pos)=6;
+md.flowequation.vertex_equation(pos)=8;
 
 %figure out solution types
 md.flowequation.isSIA  = double(any(md.flowequation.element_equation == 1));
 md.flowequation.isSSA  = double(any(md.flowequation.element_equation == 2));
-md.flowequation.isHO   = double(any(md.flowequation.element_equation == 3));
-md.flowequation.isL1L2 = double(any(md.flowequation.element_equation == 8));
-md.flowequation.isFS   = double(any(md.flowequation.element_equation == 4));
+md.flowequation.isL1L2 = double(any(md.flowequation.element_equation == 3));
+md.flowequation.isHO   = double(any(md.flowequation.element_equation == 4));
+md.flowequation.isFS   = double(any(md.flowequation.element_equation == 5));
 
 return
Index: issm/trunk/src/m/parameterization/setflowequation.py
===================================================================
--- issm/trunk/src/m/parameterization/setflowequation.py	(revision 18081)
+++ issm/trunk/src/m/parameterization/setflowequation.py	(revision 18301)
@@ -8,5 +8,5 @@
 def setflowequation(md,*args):
 	"""
-	SETELEMENTSTYPE - associate a solution type to each element
+	SETFLOWEQUATION - associate a solution type to each element
 
 	   This routine works like plotmodel: it works with an even number of inputs
@@ -232,10 +232,10 @@
 	md.flowequation.element_equation[numpy.nonzero(SIAflag)]=1
 	md.flowequation.element_equation[numpy.nonzero(SSAflag)]=2
-	md.flowequation.element_equation[numpy.nonzero(L1L2flag)]=8
-	md.flowequation.element_equation[numpy.nonzero(HOflag)]=3
-	md.flowequation.element_equation[numpy.nonzero(FSflag)]=4
-	md.flowequation.element_equation[numpy.nonzero(SSAHOflag)]=5
-	md.flowequation.element_equation[numpy.nonzero(SSAFSflag)]=6
-	md.flowequation.element_equation[numpy.nonzero(HOFSflag)]=7
+	md.flowequation.element_equation[numpy.nonzero(L1L2flag)]=3
+	md.flowequation.element_equation[numpy.nonzero(HOflag)]=4
+	md.flowequation.element_equation[numpy.nonzero(FSflag)]=5
+	md.flowequation.element_equation[numpy.nonzero(SSAHOflag)]=6
+	md.flowequation.element_equation[numpy.nonzero(SSAFSflag)]=7
+	md.flowequation.element_equation[numpy.nonzero(HOFSflag)]=8
 
 	#border
@@ -246,31 +246,31 @@
 	#Create vertices_type
 	md.flowequation.vertex_equation=numpy.zeros(md.mesh.numberofvertices,int)
+	pos=numpy.nonzero(nodeonSIA)
+	md.flowequation.vertex_equation[pos]=1
 	pos=numpy.nonzero(nodeonSSA)
 	md.flowequation.vertex_equation[pos]=2
 	pos=numpy.nonzero(nodeonL1L2)
-	md.flowequation.vertex_equation[pos]=8
+	md.flowequation.vertex_equation[pos]=3
 	pos=numpy.nonzero(nodeonHO)
-	md.flowequation.vertex_equation[pos]=3
-	pos=numpy.nonzero(nodeonSIA)
-	md.flowequation.vertex_equation[pos]=1
-	pos=numpy.nonzero(nodeonSSAHO)
+	md.flowequation.vertex_equation[pos]=4
+	pos=numpy.nonzero(nodeonFS)
 	md.flowequation.vertex_equation[pos]=5
-	pos=numpy.nonzero(nodeonFS)
-	md.flowequation.vertex_equation[pos]=4
 	if any(FSflag):
 		pos=numpy.nonzero(numpy.logical_not(nodeonFS))
 		if not (any(HOflag) or any(SSAflag)):
 			md.flowequation.vertex_equation[pos]=0
+	pos=numpy.nonzero(nodeonSSAHO)
+	md.flowequation.vertex_equation[pos]=6
 	pos=numpy.nonzero(nodeonHOFS)
 	md.flowequation.vertex_equation[pos]=7
 	pos=numpy.nonzero(nodeonSSAFS)
-	md.flowequation.vertex_equation[pos]=6
+	md.flowequation.vertex_equation[pos]=8
 
 	#figure out solution types
 	md.flowequation.isSIA=any(md.flowequation.element_equation==1)
 	md.flowequation.isSSA=any(md.flowequation.element_equation==2)
-	md.flowequation.isL1L2=any(md.flowequation.element_equation==8)
-	md.flowequation.isHO=any(md.flowequation.element_equation==3)
-	md.flowequation.isFS=any(md.flowequation.element_equation==4)
+	md.flowequation.isL1L2=any(md.flowequation.element_equation==3)
+	md.flowequation.isHO=any(md.flowequation.element_equation==4)
+	md.flowequation.isFS=any(md.flowequation.element_equation==5)
 
 	return md
Index: issm/trunk/src/m/parameterization/sethydrostaticmask.m
===================================================================
--- issm/trunk/src/m/parameterization/sethydrostaticmask.m	(revision 18301)
+++ issm/trunk/src/m/parameterization/sethydrostaticmask.m	(revision 18301)
@@ -0,0 +1,29 @@
+function md=sethydrostaticmask(md)
+%SETHYDROSTATICMASK - establish groundedice_levelset field
+%
+%   Determines grounded and floating ice position based on 
+%   md.geometry.bed and md.geometry.thickness
+%
+%   Usage:
+%      md=sethydrostaticmask(md)
+%
+%   Examples:
+%      md=sethydrostaticmask(md);
+
+if(length(md.geometry.bed)~=md.mesh.numberofvertices | length(md.geometry.thickness)~=md.mesh.numberofvertices | length(md.geometry.base)~=md.mesh.numberofvertices),
+		error('hydrostaticmask error message: fields in md.geometry do not have the right size.');
+end
+
+%grounded ice level set
+md.mask.groundedice_levelset=md.geometry.thickness+md.geometry.bed*md.materials.rho_water/md.materials.rho_ice;
+
+%Check consistency of geometry
+pos=find(md.mask.groundedice_levelset>0);
+if(any(md.geometry.base(pos)~=md.geometry.bed(pos))),
+	disp('WARNING: md.geometry.bed and md.geometry.base not equal on grounded ice');
+end
+
+pos=find(md.mask.groundedice_levelset<=0);
+if(any(md.geometry.base(pos)<md.geometry.bed(pos))),
+	disp('WARNING: md.geometry.base < md.geometry.bed on floating ice');
+end
Index: issm/trunk/src/m/parameterization/sethydrostaticmask.py
===================================================================
--- issm/trunk/src/m/parameterization/sethydrostaticmask.py	(revision 18301)
+++ issm/trunk/src/m/parameterization/sethydrostaticmask.py	(revision 18301)
@@ -0,0 +1,35 @@
+import numpy
+import os
+from model import model
+from FlagElements import FlagElements
+import pairoptions
+from ContourToMesh import ContourToMesh
+
+def setmask(md)
+	"""
+	SETHYDROSTATICMASK - establish groundedice_levelset field
+
+   Determines grounded and floating ice position based on 
+   md.geometry.bed and md.geometry.thickness
+
+   Usage:
+      md=sethydrostaticmask(md)
+
+   Examples:
+      md=sethydrostaticmask(md);
+   """
+
+	if numpy.size(md.geometry.bed,axis=0)!=md.mesh.numberofvertices or numpy.size(md.geometry.base,axis=0)!=md.mesh.numberofvertices or numpy.size(md.geometry.thickness,axis=0)!=md.mesh.numberofvertices:
+		raise IOError("hydrostaticmask error message: fields in md.geometry do not have the right size.")
+
+   # grounded ice level set
+   md.mask.groundedice_levelset=md.geometry.thickness+md.geometry.bed*md.materials.rho_water/md.materials.rho_ice
+
+   #Check consistency of geometry
+	if any(md.geometry.base[numpy.nonzero(md.mask.groundedice_levelset>0.)]!=md.geometry.bed[numpy.nonzero(md.mask.groundedice_levelset>0.)]):
+	   print "WARNING: md.geometry.bed and md.geometry.base not equal on grounded ice"
+
+	if any(md.geometry.base[numpy.nonzero(md.mask.groundedice_levelset<=0.)]<md.geometry.bed[numpy.nonzero(md.mask.groundedice_levelset<=0.)]):
+		print "WARNING: md.geometry.base < md.geometry.bed on floating ice"
+
+	return md
Index: issm/trunk/src/m/plot/applyoptions.py
===================================================================
--- issm/trunk/src/m/plot/applyoptions.py	(revision 18081)
+++ issm/trunk/src/m/plot/applyoptions.py	(revision 18301)
@@ -219,9 +219,10 @@
 			extend='both'
 		cb = mpl.colorbar.ColorbarBase(ax.cax, cmap=cmap, norm=norm, extend=extend)
-		cb.locator=MaxNLocator(nbins=5) # default 5 ticks
 		if options.exist('alpha'):
 			cb.set_alpha(options.getfieldvalue('alpha'))
 		if options.exist('colorbarnumticks'):
 			cb.locator=MaxNLocator(nbins=options.getfieldvalue('colorbarnumticks',5))
+		else:
+			cb.locator=MaxNLocator(nbins=5) # default 5 ticks
 		if options.exist('colorbartickspacing'):
 			locs=npy.arange(lims[0],lims[1]+1,options.getfieldvalue('colorbartickspacing'))
@@ -237,4 +238,5 @@
 				cb.set_label(options.getfieldvalue('colorbartitle'),fontsize=fontsize)
 		cb.ax.tick_params(labelsize=fontsize)
+		cb.update_ticks()
 		plt.sca(ax) # return to original axes control
 	#}}}
Index: issm/trunk/src/m/plot/checkplotoptions.py
===================================================================
--- issm/trunk/src/m/plot/checkplotoptions.py	(revision 18081)
+++ issm/trunk/src/m/plot/checkplotoptions.py	(revision 18301)
@@ -18,5 +18,5 @@
 		if 'km' in options.getfieldvalue('unit','km'):
 			options.changefieldvalue('unit',10**-3)
-		if '100km' in options.getfieldvalue('unit','100km'):
+		elif '100km' in options.getfieldvalue('unit','100km'):
 			options.changefieldvalue('unit',10**-5)
 	
Index: issm/trunk/src/m/plot/plot_BC.m
===================================================================
--- issm/trunk/src/m/plot/plot_BC.m	(revision 18081)
+++ issm/trunk/src/m/plot/plot_BC.m	(revision 18301)
@@ -6,21 +6,23 @@
 hold on
 
+[x y z elements is2d isplanet]=processmesh(md,[],options);
+
 %plot dirichlets
 dirichleton=getfieldvalue(options,'dirichlet','on');
 if strcmpi(dirichleton,'on'),
 	h1=plot3(...
-		md.mesh.x(find(~isnan(md.stressbalance.spcvx(1:md.mesh.numberofvertices,1)))),...
-		md.mesh.y(find(~isnan(md.stressbalance.spcvx(1:md.mesh.numberofvertices,1)))),...
-		md.mesh.z(find(~isnan(md.stressbalance.spcvx(1:md.mesh.numberofvertices,1)))),...
+		x(find(~isnan(md.stressbalance.spcvx(1:md.mesh.numberofvertices,1)))),...
+		y(find(~isnan(md.stressbalance.spcvx(1:md.mesh.numberofvertices,1)))),...
+		z(find(~isnan(md.stressbalance.spcvx(1:md.mesh.numberofvertices,1)))),...
 		'ro','MarkerSize',14,'MarkerFaceColor','r');
 	h2=plot3(...
-		md.mesh.x(find(~isnan(md.stressbalance.spcvy(1:md.mesh.numberofvertices,1)))),...
-		md.mesh.y(find(~isnan(md.stressbalance.spcvy(1:md.mesh.numberofvertices,1)))),...
-		md.mesh.z(find(~isnan(md.stressbalance.spcvy(1:md.mesh.numberofvertices,1)))),...
+		x(find(~isnan(md.stressbalance.spcvy(1:md.mesh.numberofvertices,1)))),...
+		y(find(~isnan(md.stressbalance.spcvy(1:md.mesh.numberofvertices,1)))),...
+		z(find(~isnan(md.stressbalance.spcvy(1:md.mesh.numberofvertices,1)))),...
 		'bo','MarkerSize',10,'MarkerFaceColor','b');
 	h3=plot3(...
-		md.mesh.x(find(~isnan(md.stressbalance.spcvz(1:md.mesh.numberofvertices,1)))),...
-		md.mesh.y(find(~isnan(md.stressbalance.spcvz(1:md.mesh.numberofvertices,1)))),...
-		md.mesh.z(find(~isnan(md.stressbalance.spcvz(1:md.mesh.numberofvertices,1)))),...
+		x(find(~isnan(md.stressbalance.spcvz(1:md.mesh.numberofvertices,1)))),...
+		y(find(~isnan(md.stressbalance.spcvz(1:md.mesh.numberofvertices,1)))),...
+		z(find(~isnan(md.stressbalance.spcvz(1:md.mesh.numberofvertices,1)))),...
 		'yo','MarkerSize',6 ,'MarkerFaceColor','y');
 end
Index: issm/trunk/src/m/plot/plot_elementstype.m
===================================================================
--- issm/trunk/src/m/plot/plot_elementstype.m	(revision 18081)
+++ issm/trunk/src/m/plot/plot_elementstype.m	(revision 18301)
@@ -17,79 +17,79 @@
 subplot(width,width,i);
 
+plot_unit(x,y,z,elements,data,is2d,isplanet,datatype,options);
+return;
 if is2d
-	%SIA elements
+	posNONE=find(data==0);
+	A=elements(posNONE,1); B=elements(posNONE,2); C=elements(posNONE,3); 
+	p1=patch( 'Faces', [A B C], 'Vertices', [x y z],'CData',0,'FaceColor','flat','EdgeColor',edgecolor);
 	posH=find(data==1);
 	A=elements(posH,1); B=elements(posH,2); C=elements(posH,3); 
-	p1=patch( 'Faces', [A B C], 'Vertices', [x y z],'CData',1,'FaceColor','flat','EdgeColor',edgecolor);
-	%SSA element
+	p2=patch( 'Faces', [A B C], 'Vertices', [x y z],'CData',1,'FaceColor','flat','EdgeColor',edgecolor);
 	posM=find(data==2);
 	A=elements(posM,1); B=elements(posM,2); C=elements(posM,3); 
-	p2=patch( 'Faces', [A B C], 'Vertices', [x y z],'CData',2,'FaceColor','flat','EdgeColor',edgecolor);
-	%HO element
-	posP=find(data==3);
+	posM=find(data==3);
+	A=elements(posM,1); B=elements(posM,2); C=elements(posM,3); 
+	p4=patch( 'Faces', [A B C], 'Vertices', [x y z],'CData',2,'FaceColor','flat','EdgeColor',edgecolor);
+	posP=find(data==4);
 	A=elements(posP,1); B=elements(posP,2); C=elements(posP,3); 
-	p3=patch( 'Faces', [A B C], 'Vertices', [x y z],'CData',3,'FaceColor','flat','EdgeColor',edgecolor);
-	%SSAHO element
-	posMP=find(data==5);
-	A=elements(posMP,1); B=elements(posMP,2); C=elements(posMP,3); 
-	p5=patch( 'Faces', [A B C], 'Vertices', [x y z],'CData',5,'FaceColor','flat','EdgeColor',edgecolor);
-	%FS elements
-	posS=find(data==4);
+	p5=patch( 'Faces', [A B C], 'Vertices', [x y z],'CData',3,'FaceColor','flat','EdgeColor',edgecolor);
+	posS=find(data==5);
 	A=elements(posS,1); B=elements(posS,2); C=elements(posS,3); 
 	p6=patch( 'Faces', [A B C], 'Vertices', [x y z],'CData',4,'FaceColor','flat','EdgeColor',edgecolor);
-	%SSAFS elements
-	posMS=find(data==6);
-	A=elements(posMS,1); B=elements(posMS,2); C=elements(posMS,3); 
-	p7=patch( 'Faces', [A B C], 'Vertices', [x y z],'CData',6,'FaceColor','flat','EdgeColor',edgecolor);
-	%HOFS elements
+	posMP=find(data==6);
+	A=elements(posMP,1); B=elements(posMP,2); C=elements(posMP,3); 
+	p7=patch( 'Faces', [A B C], 'Vertices', [x y z],'CData',5,'FaceColor','flat','EdgeColor',edgecolor);
 	posPS=find(data==7);
 	A=elements(posPS,1); B=elements(posPS,2); C=elements(posPS,3); 
 	p8=patch( 'Faces', [A B C], 'Vertices', [x y z],'CData',7,'FaceColor','flat','EdgeColor',edgecolor);
-	%None elements
-	posNONE=find(data==0);
-	A=elements(posNONE,1); B=elements(posNONE,2); C=elements(posNONE,3); 
-	p9=patch( 'Faces', [A B C], 'Vertices', [x y z],'CData',0,'FaceColor','flat','EdgeColor',edgecolor);
-
-	legend([p1 p2 p3 p5 p6 p7 p8 p9],...
-		'SIA''s elements','SSA''s elements','HO''s elements',...
-		'SSAHO''s elements','FS''s elements','SSAFS''s elements','HOFS''s elements','None element');
-
+	posMS=find(data==8);
+	A=elements(posMS,1); B=elements(posMS,2); C=elements(posMS,3); 
+	p9=patch( 'Faces', [A B C], 'Vertices', [x y z],'CData',6,'FaceColor','flat','EdgeColor',edgecolor);
 else
-	%SIA elements
+	PosNONE=find(data==0);
+	A=elements(PosNONE,1); B=elements(PosNONE,2); C=elements(PosNONE,3); D=elements(PosNONE,4); E=elements(PosNONE,5); F=elements(PosNONE,6);
+	p1=patch( 'Faces', [A B C],'Vertices', [x y z],'CData', 0,'FaceColor','flat','EdgeColor',edgecolor);
+	patch( 'Faces', [D E F],  'Vertices', [x y z],'CData', 0,'FaceColor','flat','EdgeColor',edgecolor);
+	patch( 'Faces', [A B E D],'Vertices', [x y z],'CData', 0,'FaceColor','flat','EdgeColor',edgecolor);
+	patch( 'Faces', [B E F C],'Vertices', [x y z],'CData', 0,'FaceColor','flat','EdgeColor',edgecolor);
+	patch( 'Faces', [C A D F],'Vertices', [x y z],'CData', 0,'FaceColor','flat','EdgeColor',edgecolor);
 	posH=find(data==1);
 	A=elements(posH,1); B=elements(posH,2); C=elements(posH,3); D=elements(posH,4); E=elements(posH,5); F=elements(posH,6);
-	p1=patch( 'Faces', [A B C],'Vertices', [x y z],'CData', 1,'FaceColor','flat','EdgeColor',edgecolor);
+	p2=patch( 'Faces', [A B C],'Vertices', [x y z],'CData', 1,'FaceColor','flat','EdgeColor',edgecolor);
 	patch( 'Faces', [D E F],  'Vertices', [x y z],'CData', 1,'FaceColor','flat','EdgeColor',edgecolor);
 	patch( 'Faces', [A B E D],'Vertices', [x y z],'CData', 1,'FaceColor','flat','EdgeColor',edgecolor);
 	patch( 'Faces', [B E F C],'Vertices', [x y z],'CData', 1,'FaceColor','flat','EdgeColor',edgecolor);
 	patch( 'Faces', [C A D F],'Vertices', [x y z],'CData', 1,'FaceColor','flat','EdgeColor',edgecolor);
-	%SSA elements
 	posM=find(data==2);
 	A=elements(posM,1); B=elements(posM,2); C=elements(posM,3); D=elements(posM,4); E=elements(posM,5); F=elements(posM,6);
-	p2=patch( 'Faces', [A B C],'Vertices', [x y z],'CData', 2,'FaceColor','flat','EdgeColor',edgecolor);
+	p3=patch( 'Faces', [A B C],'Vertices', [x y z],'CData', 2,'FaceColor','flat','EdgeColor',edgecolor);
 	patch( 'Faces', [D E F],  'Vertices', [x y z],'CData', 2,'FaceColor','flat','EdgeColor',edgecolor);
 	patch( 'Faces', [A B E D],'Vertices', [x y z],'CData', 2,'FaceColor','flat','EdgeColor',edgecolor);
 	patch( 'Faces', [B E F C],'Vertices', [x y z],'CData', 2,'FaceColor','flat','EdgeColor',edgecolor);
 	patch( 'Faces', [C A D F],'Vertices', [x y z],'CData', 2,'FaceColor','flat','EdgeColor',edgecolor);
-	%HO elements
 	posP=find(data==3);
 	A=elements(posP,1); B=elements(posP,2); C=elements(posP,3); D=elements(posP,4); E=elements(posP,5); F=elements(posP,6);
-	p3=patch( 'Faces', [A B C],'Vertices', [x y z],'CData', 3,'FaceColor','flat','EdgeColor',edgecolor);
+	p4=patch( 'Faces', [A B C],'Vertices', [x y z],'CData', 3,'FaceColor','flat','EdgeColor',edgecolor);
 	patch( 'Faces', [D E F],  'Vertices', [x y z],'CData', 3,'FaceColor','flat','EdgeColor',edgecolor);
 	patch( 'Faces', [A B E D],'Vertices', [x y z],'CData', 3,'FaceColor','flat','EdgeColor',edgecolor);
 	patch( 'Faces', [B E F C],'Vertices', [x y z],'CData', 3,'FaceColor','flat','EdgeColor',edgecolor);
 	patch( 'Faces', [C A D F],'Vertices', [x y z],'CData', 3,'FaceColor','flat','EdgeColor',edgecolor);
-	%FS elements
+	posP=find(data==3);
+	A=elements(posP,1); B=elements(posP,2); C=elements(posP,3); D=elements(posP,4); E=elements(posP,5); F=elements(posP,6);
+	p5=patch( 'Faces', [A B C],'Vertices', [x y z],'CData', 3,'FaceColor','flat','EdgeColor',edgecolor);
+	patch( 'Faces', [D E F],  'Vertices', [x y z],'CData', 3,'FaceColor','flat','EdgeColor',edgecolor);
+	patch( 'Faces', [A B E D],'Vertices', [x y z],'CData', 3,'FaceColor','flat','EdgeColor',edgecolor);
+	patch( 'Faces', [B E F C],'Vertices', [x y z],'CData', 3,'FaceColor','flat','EdgeColor',edgecolor);
+	patch( 'Faces', [C A D F],'Vertices', [x y z],'CData', 3,'FaceColor','flat','EdgeColor',edgecolor);
 	posS=find(data==4);
 	A=elements(posS,1); B=elements(posS,2); C=elements(posS,3); D=elements(posS,4); E=elements(posS,5); F=elements(posS,6);
-	p4=patch( 'Faces', [A B C],'Vertices', [x y z],'CData', 4,'FaceColor','flat','EdgeColor',edgecolor);
+	p6=patch( 'Faces', [A B C],'Vertices', [x y z],'CData', 4,'FaceColor','flat','EdgeColor',edgecolor);
 	patch( 'Faces', [D E F],  'Vertices', [x y z],'CData', 4,'FaceColor','flat','EdgeColor',edgecolor);
 	patch( 'Faces', [A B E D],'Vertices', [x y z],'CData', 4,'FaceColor','flat','EdgeColor',edgecolor);
 	patch( 'Faces', [B E F C],'Vertices', [x y z],'CData', 4,'FaceColor','flat','EdgeColor',edgecolor);
 	patch( 'Faces', [C A D F],'Vertices', [x y z],'CData', 4,'FaceColor','flat','EdgeColor',edgecolor);
-	%SSAHO elements
 	posP=find(data==5);
 	A=elements(posP,1); B=elements(posP,2); C=elements(posP,3); D=elements(posP,4); E=elements(posP,5); F=elements(posP,6);
-	p5=patch( 'Faces', [A B C],'Vertices', [x y z],'CData', 5,'FaceColor','flat','EdgeColor',edgecolor);
+	p7=patch( 'Faces', [A B C],'Vertices', [x y z],'CData', 5,'FaceColor','flat','EdgeColor',edgecolor);
 	patch( 'Faces', [D E F],  'Vertices', [x y z],'CData', 5,'FaceColor','flat','EdgeColor',edgecolor);
 	patch( 'Faces', [A B E D],'Vertices', [x y z],'CData', 5,'FaceColor','flat','EdgeColor',edgecolor);
@@ -99,30 +99,21 @@
 	PosPS=find(data==7);
 	A=elements(PosPS,1); B=elements(PosPS,2); C=elements(PosPS,3); D=elements(PosPS,4); E=elements(PosPS,5); F=elements(PosPS,6);
-	p6=patch( 'Faces', [A B C],'Vertices', [x y z],'CData', 7,'FaceColor','flat','EdgeColor',edgecolor);
+	p8=patch( 'Faces', [A B C],'Vertices', [x y z],'CData', 7,'FaceColor','flat','EdgeColor',edgecolor);
 	patch( 'Faces', [D E F],  'Vertices', [x y z],'CData', 7,'FaceColor','flat','EdgeColor',edgecolor);
 	patch( 'Faces', [A B E D],'Vertices', [x y z],'CData', 7,'FaceColor','flat','EdgeColor',edgecolor);
 	patch( 'Faces', [B E F C],'Vertices', [x y z],'CData', 7,'FaceColor','flat','EdgeColor',edgecolor);
 	patch( 'Faces', [C A D F],'Vertices', [x y z],'CData', 7,'FaceColor','flat','EdgeColor',edgecolor);
-	%SSAFS elements
 	PosMS=find(data==6);
 	A=elements(PosMS,1); B=elements(PosMS,2); C=elements(PosMS,3); D=elements(PosMS,4); E=elements(PosMS,5); F=elements(PosMS,6);
-	p7=patch( 'Faces', [A B C],'Vertices', [x y z],'CData', 6,'FaceColor','flat','EdgeColor',edgecolor);
+	p9=patch( 'Faces', [A B C],'Vertices', [x y z],'CData', 6,'FaceColor','flat','EdgeColor',edgecolor);
 	patch( 'Faces', [D E F],  'Vertices', [x y z],'CData', 6,'FaceColor','flat','EdgeColor',edgecolor);
 	patch( 'Faces', [A B E D],'Vertices', [x y z],'CData', 6,'FaceColor','flat','EdgeColor',edgecolor);
 	patch( 'Faces', [B E F C],'Vertices', [x y z],'CData', 6,'FaceColor','flat','EdgeColor',edgecolor);
 	patch( 'Faces', [C A D F],'Vertices', [x y z],'CData', 6,'FaceColor','flat','EdgeColor',edgecolor);
-	%None elements
-	PosNONE=find(data==0);
-	A=elements(PosNONE,1); B=elements(PosNONE,2); C=elements(PosNONE,3); D=elements(PosNONE,4); E=elements(PosNONE,5); F=elements(PosNONE,6);
-	p8=patch( 'Faces', [A B C],'Vertices', [x y z],'CData', 0,'FaceColor','flat','EdgeColor',edgecolor);
-	patch( 'Faces', [D E F],  'Vertices', [x y z],'CData', 0,'FaceColor','flat','EdgeColor',edgecolor);
-	patch( 'Faces', [A B E D],'Vertices', [x y z],'CData', 0,'FaceColor','flat','EdgeColor',edgecolor);
-	patch( 'Faces', [B E F C],'Vertices', [x y z],'CData', 0,'FaceColor','flat','EdgeColor',edgecolor);
-	patch( 'Faces', [C A D F],'Vertices', [x y z],'CData', 0,'FaceColor','flat','EdgeColor',edgecolor);
 
-	legend([p1 p2 p3 p4 p5 p6 p7 p8],...
-		'SIA''s elements','SSA''s elements','HO''s elements','FS''s elements',...
-		'SSAHO''s elements','HOFS''s elements','SSAFS''s elements','None elements');
 end
+legend([p1 p2 p3 p4 p5 p6 p7 p8 p9],...
+		'None','SIA','SSA','L1L2','HO',...
+		'SSAHO','FS','SSAFS','HOFS');
 
 %apply options
Index: issm/trunk/src/m/plot/plot_scatter.m
===================================================================
--- issm/trunk/src/m/plot/plot_scatter.m	(revision 18081)
+++ issm/trunk/src/m/plot/plot_scatter.m	(revision 18301)
@@ -6,4 +6,5 @@
 %
 %   Available options:
+%      'caxis'      : default is full range
 %      'MarkerSize' : default is 3
 %      'Line'       : use line instead of circles
@@ -25,4 +26,9 @@
 Min=min(level);
 Max=max(level);
+if exist(options,'caxis');
+	range=getfieldvalue(options,'caxis');
+	Min=min(range);
+	Max=max(range);
+end
 Siz=length(level);
 nlab=10;
Index: issm/trunk/src/m/plot/plot_transient_movie.m
===================================================================
--- issm/trunk/src/m/plot/plot_transient_movie.m	(revision 18081)
+++ issm/trunk/src/m/plot/plot_transient_movie.m	(revision 18301)
@@ -13,5 +13,20 @@
 		field=getfieldvalue(options,'transient_movie_field');
 	else
-		error('specify transient_movie_field in options list');
+		disp('List of available fields:');
+		F=fields(md.results.TransientSolution(1));
+		num = [];
+		for i=1:numel(F),
+			if ~strcmp(F{i},'time') & ...
+				~strcmp(F{i},'step') & ...
+				~strcmp(F{i},'errlog') & ...
+				~strcmp(F{i},'outlog') & ...
+				~strcmp(F{i},'MaxIterationConvergenceFlag') & ...
+				~strcmp(F{i},'SolutionType'),
+				disp(['   ' num2str(i) ': ' F{i} ]);
+				num = [num i];
+			end
+		end
+		choice=input(['please enter the field number? (between ' num2str(min(num)) ' and ' num2str(max(num)) ')  ']);
+		field =  F{choice};
 	end
 
@@ -24,6 +39,19 @@
 		steps=1:length(results);
 	end
-	results=md.results.TransientSolution;
+
+	%calculate caxis
+	if ~exist(options,'caxis'),
+		range = [Inf -Inf];
+		for i=steps
+			[data datatype]=processdata(md,results(i).(field),options);
+			range(1) = min(range(1),min(data));
+			range(2) = max(range(2),max(data));
+		end
+		options=addfielddefault(options,'caxis',range);
+	end
+
+	%display movie
 	nstep=1;
+	deltat = getfieldvalue(options,'pause',.5);
 	for i=steps
 
@@ -33,4 +61,5 @@
 			[data datatype]=processdata(md,results(i).(field),options);
 
+			clf;
 			titlestring=[field ' at time ' num2str(results(i).time/md.constants.yts) ' year'];
 			plot_unit(x,y,z,elements,data,is2d,isplanet,datatype,options)
@@ -49,5 +78,5 @@
 				end
 			else
-				pause(0.1)
+				pause(deltat)
 			end
 			nstep=nstep+1;
Index: issm/trunk/src/m/plot/plot_unit.m
===================================================================
--- issm/trunk/src/m/plot/plot_unit.m	(revision 18081)
+++ issm/trunk/src/m/plot/plot_unit.m	(revision 18301)
@@ -16,7 +16,5 @@
 
 		pos=find(~isnan(data)); %needed for element on water
-		if is2d,
-			A=elements(pos,1); B=elements(pos,2); C=elements(pos,3); patch( 'Faces', [A B C], 'Vertices', [x y z],'CData', data(pos),'FaceColor','flat','EdgeColor',edgecolor);
-		else
+		if size(elements,2)==6, %prisms
 			A=elements(pos,1); B=elements(pos,2); C=elements(pos,3); D=elements(pos,4); E=elements(pos,5); F=elements(pos,6);
 			patch( 'Faces', [A B C],  'Vertices', [x y z],'CData', data(pos),'FaceColor','flat','EdgeColor',edgecolor);
@@ -25,4 +23,16 @@
 			patch( 'Faces', [B E F C],'Vertices', [x y z],'CData', data(pos),'FaceColor','flat','EdgeColor',edgecolor);
 			patch( 'Faces', [C A D F],'Vertices', [x y z],'CData', data(pos),'FaceColor','flat','EdgeColor',edgecolor);
+		elseif size(elements,2)==4, %tetras
+			A=elements(:,1); B=elements(:,2); C=elements(:,3); D=elements(:,4);
+			patch( 'Faces',[A B C],'Vertices', [x y z],'CData',data(pos),'FaceColor','flat','EdgeColor',edgecolor);
+			patch( 'Faces',[A B D],'Vertices', [x y z],'CData',data(pos),'FaceColor','flat','EdgeColor',edgecolor);
+			patch( 'Faces',[B C D],'Vertices', [x y z],'CData',data(pos),'FaceColor','flat','EdgeColor',edgecolor);
+			patch( 'Faces',[C A D],'Vertices', [x y z],'CData',data(pos),'FaceColor','flat','EdgeColor',edgecolor);
+		else
+			A=elements(pos,1); B=elements(pos,2); C=elements(pos,3);
+			patch( 'Faces', [A B C], 'Vertices', [x y z],'CData', data(pos),'FaceColor','flat','EdgeColor',edgecolor);
+		end
+
+		if is2d,
 		end
 
Index: issm/trunk/src/m/plot/plotdoc.m
===================================================================
--- issm/trunk/src/m/plot/plotdoc.m	(revision 18081)
+++ issm/trunk/src/m/plot/plotdoc.m	(revision 18301)
@@ -12,5 +12,5 @@
 disp('                Available values for ''data'' are: ');
 disp('                  - any field of the model structure. ex: plot(md,''data'',''vel''), or plot(md,''data'',md.initialization.vel)');
-disp('                  - ''basal_drag'': plot the basal drag on the bed (in kPa)');
+disp('                  - ''basal_drag'': plot the basal drag on the bed (in kPa) based on the velocity in md.initialization');
 disp('                  - ''basal_dragx'' or ''basal_dragy'' : plot a component of the basal drag on the bed (in kPa)');
 disp('                  - ''boundaries'': this will draw all the segment boundaries to the model, including rifts.');
Index: issm/trunk/src/m/plot/plotmodel.py
===================================================================
--- issm/trunk/src/m/plot/plotmodel.py	(revision 18081)
+++ issm/trunk/src/m/plot/plotmodel.py	(revision 18301)
@@ -54,6 +54,6 @@
 	if numberofplots:
 		
-		if plt.fignum_exists(figurenumber): 
-			plt.cla()
+		#if plt.fignum_exists(figurenumber): 
+		#	plt.cla()
 
 		#if figsize specified
Index: issm/trunk/src/m/plot/processdata.m
===================================================================
--- issm/trunk/src/m/plot/processdata.m	(revision 18081)
+++ issm/trunk/src/m/plot/processdata.m	(revision 18301)
@@ -15,4 +15,15 @@
 if (iscell(data) | isempty(data) | length(data)==0 | (length(data)==1 & ~isstruct(data) & isnan(data))),
 	error('plotmodel error message: data provided is empty');
+end
+
+%specials for struct
+if isstruct(data),
+	disp('data provided is a struct with the following fields:');
+	F=fields(data);
+	for i=1:numel(F),
+		disp(['   ' num2str(i) ': ' F{i} ]);
+	end
+	choice=input(['please enter the field number? (between 1 and ' num2str(numel(F)) ')  ']);
+	[data datatype]=processdata(md,data.(F{choice}),options);
 end
 
Index: issm/trunk/src/m/solve/parseresultsfromdisk.m
===================================================================
--- issm/trunk/src/m/solve/parseresultsfromdisk.m	(revision 18081)
+++ issm/trunk/src/m/solve/parseresultsfromdisk.m	(revision 18301)
@@ -178,5 +178,5 @@
 	elseif strcmp(fieldname,'Vel'),
 		field = field*yts;
-	elseif strcmp(fieldname,'BasalforcingsMeltingRate'),
+	elseif strcmp(fieldname,'BasalforcingsGroundediceMeltingRate'),
 		field = field*yts;
 	elseif strcmp(fieldname,'TotalSmb'),
Index: issm/trunk/src/m/solve/parseresultsfromdisk.py
===================================================================
--- issm/trunk/src/m/solve/parseresultsfromdisk.py	(revision 18081)
+++ issm/trunk/src/m/solve/parseresultsfromdisk.py	(revision 18301)
@@ -178,5 +178,5 @@
 		elif m.strcmp(fieldname,'Vel'):
 			field = field*yts
-		elif m.strcmp(fieldname,'BasalforcingsMeltingRate'):
+		elif m.strcmp(fieldname,'BasalforcingsGroundediceMeltingRate'):
 			field = field*yts
 		elif m.strcmp(fieldname,'TotalSmb'):
